(function() {
    openerp.widgetInstanceStatementPosConfirm = null;
    openerp.parentInstanceStatementPosConfirm = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;

    openerp.EiruStatementPosConfirm = openerp.Widget.extend({
        template: 'EiruStatementPos.Confirm',
        id: undefined,
        posSession: [],
        statementConfig: [],
        statementClose: [],

        /* init */
        init: function(parent) {
            this._super(parent);
        },
        /* start */
        start: function () {
            var self = this
            this.$el.click(function() {
                self.fetchInitial();
            });
        },
        /* Actualizar Id de la visat actual  */
        updateId: function(id) {
            var self = this;
            self.id = id;
            self.$el.css('display','flex');
            if(!id)
                self.$el.css('display','none');
        },
        /* Reload Page*/
        reloadPage: function() {
             openerp.parentInstanceStatementPosConfirm.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial */
        fetchInitial: function() {
            var self = this;
            self.fetchPosSession(self.id).then(function(posSession) {
                return posSession;
            }).then(function(posSession) {
                self.posSession = posSession;
                return self.fetchPosStatementConfig();
            }).then(function(statementConfig){
                self.statementConfig = statementConfig;
                return self.generateStatemenClose();
            }).then(function(statementClose){
                self.statementClose = statementClose;
                if (statementClose.length) {
                    return self.showModalStatementClose();
                }else {
                    return self.poseSessionClose(self.id);
                }
            }).then(function(closePos){
                self.reloadPage();
            });
        },
        /* GET pos Session */
        fetchPosSession: function(id) {
            var posSession = new instanceWeb.Model('pos.session');
            return posSession.call('eiru_get_pos_session_statement',[id], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /* Get confihuration Statement Pos */
        fetchPosStatementConfig: function() {
            var self = this;
            var statementConfig = new instanceWeb.Model('account.bank.statement.config');
            var fields = ['id','pos_journal_permitted','pos_statement_output','pos_statement_transfer'];
            var domain = [['active', '=', true]];
            return statementConfig.query(fields).filter(domain).all();
        },
        /* Preparar la lista de caja */
        generateStatemenClose: function() {
            var self = this;
            var posConfig = self.statementConfig[0];
            var pos = self.posSession;
            var statement = pos.statement;
            var posClose = [];

            _.each(statement, function(item, index) {
                /* Caja habilitadas */
                if (_.contains(posConfig.pos_journal_permitted, item.journalId)) {
                    var generalStatement = item.statementGeneral
                    if (generalStatement.length) {
                        generalStatement.unshift({
                            'id': '',
                            'name': ''
                        });
                    }

                    posClose.push({
                        'id': item.id,
                        'name': item.name +" - "+item.currency[0].symbol,
                        'amountConfirm': 0,
                        'amountOutput': 0,
                        'posStatementOutput': posConfig.pos_statement_output,
                        'statementTransfer': generalStatement,
                        'statementSelected': '',
                        'amountTransfer': 0,
                        'posStatementTransfer': !!posConfig.pos_statement_transfer && !!generalStatement.length ?posConfig.pos_statement_transfer : false,
                        'amountResidual': 0,
                        'currency': item.currency[0],
                        'casboxDisable': false,
                    })
                }

                /* deshabilitada */
                if (!(_.contains(posConfig.pos_journal_permitted, item.journalId))) {
                    posClose.push({
                        'id': item.id,
                        'name': item.name +" - "+item.currency[0].symbol,
                        'amountConfirm': item.amount,
                        'amount': instanceWeb.formatCurrency(item.amount,item.currency[0]),
                        'amountOutput': 0,
                        'posStatementOutput': false,
                        'statementTransfer': [],
                        'statementSelected': '',
                        'amountTransfer': 0,
                        'posStatementTransfer': false,
                        'amountResidual': 0,
                        'currency': item.currency[0],
                        'casboxDisable': true,
                    })
                }

            });

            return posClose;
        },
        /* Get Statemen Close */
        getStatmenClose: function(id) {
            var self = this;
            return _.filter(self.statementClose, function(item){
                return item.id === id;
            });
        },
        /* Modal */
        showModalStatementClose: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;

            var modal = QWeb.render('EiruStatementPosConfirm.Modal',{
                'statementClose':self.statementClose
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            var buttonGuardar = $('.expired-account-modal').find('.button-guardar');

            /* Keyup */
            tableRow.keyup(function(e) {

                if (($(e.target).index() !== 0) || (($(e.target).index() === 0) && ($(e.target)[0].className === 'statement-transfer')))
                    return false;


                className =($(e.target)[0].className).split(' ')

                idRow = parseInt(($(e.target).closest('tr').children()[0].textContent).trim());
                statementConfirm = self.getStatmenClose(idRow).shift();
                if (!statementConfirm)
                    return  false;
                currency = statementConfirm.currency;


                var amountConfirm = $($(e.target).closest('tr').children()[2]).find('.amount-confirm');
                var amountOutput = $($(e.target).closest('tr').children()[3]).find('.amount-output');
                var amountTransfer =$($(e.target).closest('tr').children()[5]).find('.amount-transfer');
                var amountResidual = $($(e.target).closest('tr').children()[6]).find('.amount-residual');


                /**
                 * [ Amount Confirm]
                 * Valor dl cierre de caja
                 */
                if ( _.contains(className,'amount-confirm')) {
                    if (e.key === currency.decimalSeparator && currency.decimalPlaces > 0)
                        return false ;

                    var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                    amount = instanceWeb.formatCurrency(amount, currency);

                    amountConfirm.val(amount);
                    amountConfirm.css('border-color','#ccc');
                }

                /**
                 * [ AMOUNT OUTPUT ]
                 * Sacar dinero de la caja
                 */
                if (_.contains(className, 'amount-output')) {
                    if (e.key === currency.decimalSeparator && currency.decimalPlaces > 0)
                        return false ;

                    var confirmAmont = instanceWeb.unFormatCurrency(amountConfirm.val());
                    var amount = instanceWeb.unFormatCurrency(amountOutput.val());
                    var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                    if (amount > (confirmAmont - transferAmount)) {
                        instanceWeb.notification.do_warn("Atencion", "El valor supera el saldo disponible en la caja");
                        amount = 0;
                    }
                    amount = instanceWeb.formatCurrency(amount, currency);

                    amountOutput.val(amount);
                    amountOutput.css('border-color','#ccc');
                }

                /**
                 * [AMOUNT TRANSFER]
                 * Valor de la transferencia
                 */
                if (_.contains(className, 'amount-transfer')) {
                    if (e.key === currency.decimalSeparator && currency.decimalPlaces > 0)
                        return false ;

                    var confirmAmont = instanceWeb.unFormatCurrency(amountConfirm.val());
                    var outputAmount = instanceWeb.unFormatCurrency(amountOutput.val());
                    var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                    if (transferAmount > (confirmAmont - outputAmount)) {
                        instanceWeb.notification.do_warn("Atencion", "El valor supera el saldo disponible en la caja");
                        transferAmount = 0;
                    }
                    transferAmount = instanceWeb.formatCurrency(transferAmount, currency);

                    amountTransfer.val(transferAmount);
                    amountTransfer.css('border-color','#ccc');
                }
            });
            /* Focus In */
            tableRow.focusin(function(e){
                if (($(e.target).index() !== 0))
                    return false;

                className =($(e.target)[0].className).split(' ')
                idRow = parseInt(($(e.target).closest('tr').children()[0].textContent).trim());
                statementConfirm = self.getStatmenClose(idRow).shift();
                if (!statementConfirm)
                    return  false;

                currency = statementConfirm.currency;


                if (_.contains(className, 'amount-confirm')) {
                    var amountConfirm = $($(e.target).closest('tr').children()[2]).find('.amount-confirm');
                    var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                    amount = instanceWeb.formatCurrency(amount, currency);
                    amountConfirm.val(amount > 0 ?amount : '' );
                }

            });
            /* Focus Out */
            tableRow.focusout(function(e) {
                if ($(e.target).index() !== 0)
                    return false;

                className =($(e.target)[0].className).split(' ');
                idRow = parseInt(($(e.target).closest('tr').children()[0].textContent).trim());
                statementConfirm = self.getStatmenClose(idRow).shift();
                if (!statementConfirm)
                    return  false;

                currency = statementConfirm.currency;

                var amountConfirm = $($(e.target).closest('tr').children()[2]).find('.amount-confirm');
                var amountOutput = $($(e.target).closest('tr').children()[3]).find('.amount-output');
                var statementTransfer = $($(e.target).closest('tr').children()[4]).find('.statement-transfer');
                var amountTransfer =$($(e.target).closest('tr').children()[5]).find('.amount-transfer');
                var amountResidual = $($(e.target).closest('tr').children()[6]).find('.amount-residual');
                self.statementClose

                /* amount-confirm */
                if (_.contains(className,'amount-confirm')) {
                    var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                    var outputAmont = instanceWeb.unFormatCurrency(amountOutput.val());
                    var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                    if (amount < (outputAmont + transferAmount)){
                        amountOutput.val(0);
                        amountTransfer.val(0);
                        amountResidual.val(instanceWeb.formatCurrency(amount, currency));
                        statementConfirm.amountResidual = amount;
                        statementConfirm.amountOutput = 0;
                        statementConfirm.amountTransfer = 0;
                    }else {
                        amountResidual.val(instanceWeb.formatCurrency((amount - (outputAmont + transferAmount)), currency));
                        statementConfirm.amountResidual =(amount - (outputAmont + transferAmount));

                    }
                    statementConfirm.amountConfirm = amount;
                }
                /* amount-output */
                if(_.contains(className, 'amount-output')) {
                    var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                    var outputAmont = instanceWeb.unFormatCurrency(amountOutput.val());
                    var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                    statementConfirm.amountOutput = outputAmont;
                    if ((outputAmont + transferAmount) > amount){
                        instanceWeb.notification.do_warn("Atencion", "El valor que esta retirando supera  el saldo disponible.");
                        amountOutput.val(0);
                        amountTransfer.val(0);
                        amountResidual.val(instanceWeb.formatCurrency(amount, currency));
                        statementConfirm.amountResidual = amount;
                        statementConfirm.amountOutput = 0;
                        statementConfirm.amountTransfer = 0;
                        return false;
                    }
                    amountResidual.val(instanceWeb.formatCurrency((amount - (outputAmont + transferAmount)), currency));
                    statementConfirm.amountResidual = (amount - (outputAmont + transferAmount));
                }
                /* amount-transfer */
                if (_.contains(className, 'amount-transfer')) {
                    var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                    var outputAmont = instanceWeb.unFormatCurrency(amountOutput.val());
                    var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                    statementConfirm.amountTransfer = transferAmount;
                    if ((outputAmont + transferAmount) > amount){
                        instanceWeb.notification.do_warn("Atencion", "El valor que esta retirando supera  el saldo disponible.");
                        amountOutput.val(0);
                        amountTransfer.val(0);
                        amountResidual.val(instanceWeb.formatCurrency(amount, currency));

                        statementConfirm.amountResidual = amount;
                        statementConfirm.amountOutput = 0;
                        statementConfirm.amountTransfer = 0;

                        return false;
                    }
                    amountResidual.val(instanceWeb.formatCurrency((amount - (outputAmont + transferAmount)), currency));
                    statementConfirm.amountResidual = (amount - (outputAmont + transferAmount));
                }
                /* statement-transfer */
                if (_.contains(className, 'statement-transfer')) {
                        var amount = instanceWeb.unFormatCurrency(amountConfirm.val());
                        var outputAmont = instanceWeb.unFormatCurrency(amountOutput.val());
                        var transferAmount = instanceWeb.unFormatCurrency(amountTransfer.val());

                        statementConfirm.statementSelected = statementTransfer.val();

                        if (!statementTransfer.val()) {
                            statementConfirm.statementSelected = '';
                            statementConfirm.amountTransfer = 0;
                            statementConfirm.amountResidual = (amount - (outputAmont));
                        }
                }
            });

            buttonGuardar.click(function(e) {
                var statementPos = []

                _.each(self.statementClose, function(item, index) {
                    var outputPos = !!item.posStatementOutput && item.amountOutput >0 ? item.posStatementOutput : false;
                    var transferPos = !!item.posStatementTransfer && !!item.statementSelected.length && item.amountTransfer >0 ?item.posStatementTransfer : false;

                    statementPos.push({
                        'id': item.id,
                        'amountConfirm': item.amountConfirm,
                        'OutputPos': outputPos,
                        'amountOutput': !!outputPos ? item.amountOutput : 0,
                        'transferPos':  transferPos,
                        'statementTransfer': !!transferPos ? parseInt(item.statementSelected) : '',
                        'amountTransfer': !!transferPos ? item.amountTransfer : 0,
                    })
                });

                if (!statementPos.length) {
                    return false;
                }


                $('.expired-account-modal').find('.widget-content.widget-loading-statement-pos').css('display','flex');
                self.confirmStatementPos(statementPos).then(function(statementConfirm){
                    return statementConfirm;
                }).then(function(statementConfirm) {
                    if (!statementConfirm.state) {
                        instanceWeb.notification.do_warn("Atencion", statementConfirm.message);
                        return false;
                        $('.expired-account-modal').find('.widget-content.widget-loading-statement-pos').css('display','none');
                    }
                    return self.poseSessionClose(self.id);
                }).then(function(close) {
                    self.reloadPage();
                    $('.expired-account-modal').find('.widget-content.widget-loading-statement-pos').css('display','none');
                    defer.resolve(results);
                    self.removeModal(e);
                });
            });

            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function(e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            return defer;
        },
        /* Confirm Statement Pos */
        confirmStatementPos: function(statementPos) {
            var self = this;
            var posSession = new instanceWeb.Model('pos.session');
            return posSession.call('eiru_statement_confirm_pos',[self.id, statementPos], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /* Account bank Statement  Open*/
        poseSessionClose: function(id) {
            var posSession = new instanceWeb.Model('pos.session');
            return posSession.call('eiru_pos_session_close',[id], {
                context: new instanceWeb.CompoundContext()
            });
        },

    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'pos.session')
                    return;

                openerp.parentInstanceStatementPosConfirm = this;

                if (openerp.widgetInstanceStatementPosConfirm) {
                    openerp.widgetInstanceStatementPosConfirm.updateId(record.id);
                    if (this.$el.find('.button-pos-confim').length !== 0 )
                        return ;
                }

                if (this.$el.find('.button-pos-confim').length !== 0 )
                    return;

                openerp.widgetInstanceStatementPosConfirm = new openerp.EiruStatementPosConfirm(this);
                var element =this.$el.find('.oe_form').find('.eiru-statement-pos');

                openerp.widgetInstanceStatementPosConfirm.appendTo(element[0]);
                openerp.widgetInstanceStatementPosConfirm.updateId(record.id);
            }
        });
    }
})();
