(function() {

    openerp.widgetInstanceStatementPosPrint = null;
    openerp.parentInstanceStatementPosPrint = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;

    openerp.EiruStatementPosPrint = openerp.Widget.extend({
        template: 'EiruStatementPos.Print',
        id: undefined,
        posStatementConfirm: [],
        /* init */
        init: function(parent) {
            this._super(parent);
        },
        /* start */
        start: function () {
            var self = this
            this.$el.click(function() {
                self.fetchInitial();
            });
        },
        /* Actualizar Id de la visat actual  */
        updateId: function(id) {
            var self = this;
            self.id = id;
            self.$el.css('display','flex');
            if(!id)
                self.$el.css('display','none');
        },
        /* Reload Page*/
        reloadPage: function() {
             openerp.parentInstanceStatementPosPrint.reload();
        },

        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial */
        fetchInitial: function() {
            var self = this;
            self.fetchCashboxStatementConfirmPos(self.id).then(function(posStatementConfirm) {
                return posStatementConfirm;
            }).then(function(posStatementConfirm) {
                self.posStatementConfirm = posStatementConfirm;
                return  self.printSelectedType();
            });
        },
        /* Account bank Statement  Open*/
        fetchCashboxStatementConfirmPos: function(id) {
            var statementConfirm = new instanceWeb.Model('pos.session');
            return statementConfirm.call('confirm_pos_get_statement_print',[id], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /*print select type */
        printSelectedType: function(){
            var self = this;
            var modal = QWeb.render('ModalStatementUtility.ConfirmPrint');
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var printTicket =  $('.expired-account-modal').find('.print-ticket');
            var printNormal =  $('.expired-account-modal').find('.print-normal');

            /* print Ticket */
            printTicket.click(function(e){
                self.drawPdfConfirmStatementTicket();
                self.removeModal(e);
            });

            /*print Normal */
            printNormal.click(function(e){
                self.drawPdfConfirmStatementNormal();
                self.removeModal(e);
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();
            $('.expired-account-modal').on('hidden.bs.modal', function(e) {
                self.removeModal(e);
            });
        },
        /* pdf normal */
        drawPdfConfirmStatementNormal: function() {
            var self = this;
            var pdfDoc = new jsPDF();
            pdfDoc.page = 1;

            var posStatementConfirm = self.posStatementConfirm[0];
            if (!posStatementConfirm) {
                return false
            }

            var y = 15;
            var space = 7;

            /*fin */
            pdfDoc.setFontSize('15');
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(104,y, pdfDoc.splitTextToSize(posStatementConfirm.name, 180) , null, null, 'center');
            y += space;
            pdfDoc.setFontSize('12');
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(30,y, 'Fecha de apertura:');
            pdfDoc.text(110,y, 'Fecha de cierre:');

            pdfDoc.setFontStyle('normal');
            pdfDoc.text(70,y, moment(posStatementConfirm.startAt).format('DD-MM-YYYY'));
            pdfDoc.text(150, y, moment(posStatementConfirm.stopAt).format('DD-MM-YYYY'));
            /* footer */
            pdfDoc.setFontSize('10');
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(180,290, 'Pagina ' + pdfDoc.page);

            y = 30;
            _.each(posStatementConfirm.statemnt, function(item, index){
                if (index > 0 && index < posStatementConfirm.statemnt.length)
                    y+=65;
                    if (y > 225) {
                        pdfDoc.addPage();
                        pdfDoc.page ++;
                        y =10
                        pdfDoc.setFontSize('10');
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.text(180,290, 'Pagina ' + pdfDoc.page);
                    }

                currency = item.currency[0];
                confirm = item.confirm[0]
                pdfDoc.setFontSize('12');
                pdfDoc.setFontStyle('bold');
                pdfDoc.text(104,y, pdfDoc.splitTextToSize(item.name +" - "+ item.journalName +" - "+currency.localName, 180) , null, null, 'center');

                /* Table */
                var getColumns = [
                    { 'title': 'Operación ', 'dataKey': 'ref'},
                    { 'title': 'Monto', 'dataKey': 'amount'}
                ]

                rowsPdf = [
                    {'ref': 'Saldo teórico de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountStatement,currency)},
                    { 'ref': 'Saldo real de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountConfirm,currency)},
                    { 'ref': 'Diferencia de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountDifference,currency)},
                    {'ref': 'Retiro de dinero', 'amount': instanceWeb.formatCurrency(confirm.amountOutput,currency)},
                    { 'ref': 'Transferencia a caja general ', 'amount': instanceWeb.formatCurrency(confirm.amountTransfer,currency)},
                    { 'ref': 'Reserva para la próxima apertura', 'amount': instanceWeb.formatCurrency(confirm.amountNextOpen,currency)}
                ]

                pdfDoc.autoTable(getColumns, rowsPdf, {
                    theme: 'grid',
                    startY: y+3,
                    columnStyles: {
                        amount : {halign:'right' },
                    },
                    margin: { top: 5, horizontal: 20},
                });
            })
            /* FOOTER */
            y = 280;
            pdfDoc.setFontSize('12');
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(150,y, pdfDoc.splitTextToSize('.......................................................................', 180) , null, null, 'center');
            y +=5;
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(40,y, 'Responsable de la caja ');
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(150,y, pdfDoc.splitTextToSize(posStatementConfirm.userName, 180) , null, null, 'center');
            /* Guardar */
            pdfDoc.save('RESUME DE CAJA '+posStatementConfirm.name.toUpperCase()+'.pdf');
            return true;
        },
        /* pdf ticket */
        drawPdfConfirmStatementTicket: function () {
            var self = this;
            var rowsPdf = []
            var pdfDoc = new jsPDF({
                      orientation: 'p',
                      unit: 'mm',
                      format: [76, 297]
                    })

            var posStatementConfirm = self.posStatementConfirm[0];
            if (!posStatementConfirm)
                return false

            var y = 4;
            var space = 6;
            y = 4;
            pdfDoc.setFontSize('11');
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(30,y, pdfDoc.splitTextToSize(posStatementConfirm.name, 70) , null, null, 'center');

            y += space;
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(4,y, 'Fecha de apertura:');
            pdfDoc.text(38,y, moment(posStatementConfirm.startAt).format('DD-MM-YYYY'));

            y += space;
            pdfDoc.text(4,y, 'Fecha de cierre:');
            pdfDoc.text(38, y, moment(posStatementConfirm.stopAt).format('DD-MM-YYYY'));

            _.each(posStatementConfirm.statemnt, function(item){
                currency = item.currency[0];
                confirm = item.confirm[0];
                rowsPdf.push({
                    'name': item.name,
                    'journalName': item.journalName,
                    'currency': currency.localName,
                    'confirm': [
                        {'ref': 'Saldo teórico de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountStatement,currency)},
                        { 'ref': 'Saldo real de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountConfirm,currency)},
                        { 'ref': 'Diferencia de cierre', 'amount': instanceWeb.formatCurrency(confirm.amountDifference,currency)},
                        { 'ref': 'Retiro de dinero', 'amount': instanceWeb.formatCurrency(confirm.amountOutput,currency)},
                        { 'ref': 'Transferencia a caja general ', 'amount': instanceWeb.formatCurrency(confirm.amountTransfer,currency)},
                        { 'ref': 'Reserva para la próxima apertura', 'amount': instanceWeb.formatCurrency(confirm.amountNextOpen,currency)}
                    ]
                })
            })
            _.each(rowsPdf, function(item){
                y += 10;

                if ((y+72) > 297) {
                    pdfDoc.addPage();
                    y =4
                }

                pdfDoc.text(30,y, pdfDoc.splitTextToSize(item.name, 70) , null, null, 'center');
                y += 4;
                pdfDoc.text(30,y, pdfDoc.splitTextToSize(item.journalName +" - "+ item.currency, 70) , null, null, 'center');
                y += 3;
                pdfDoc.text(2, y, "================================");
                _.each(item.confirm, function(item){
                    y += 5;
                    pdfDoc.text(3, y, item.ref);
                    y += 5;
                    var x = (45 - item.amount.length)
                    pdfDoc.text(x, y, item.amount);
                })
                y += 5;
                pdfDoc.text(2, y, "================================");
            });
        //     /* FOOTER */
            y += 20;
            pdfDoc.text(30,y,  pdfDoc.splitTextToSize('.............................................', 70) , null, null, 'center');
            y+= 5;
            pdfDoc.text(30,y, pdfDoc.splitTextToSize(posStatementConfirm.userName, 70) , null, null, 'center');
            y+= 5;
            pdfDoc.text(30,y, pdfDoc.splitTextToSize('Responsable de la caja ', 70) , null, null, 'center');

            // /* Guardar */
            pdfDoc.save('RESUME DE CAJA '+posStatementConfirm.name.toUpperCase()+'.pdf');
            return true;
        },

    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'pos.session')
                    return;

                openerp.parentInstanceStatementPosPrint = this;

                if (openerp.widgetInstanceStatementPosPrint) {
                    openerp.widgetInstanceStatementPosPrint.updateId(record.id);
                    if (this.$el.find('.button-pos-confim-print').length !== 0 )
                        return ;
                }

                if (this.$el.find('.button-pos-confim-print').length !== 0 )
                    return;

                openerp.widgetInstanceStatementPosPrint = new openerp.EiruStatementPosPrint(this);
                var element =this.$el.find('.oe_form').find('.eiru-statement-pos-print');

                openerp.widgetInstanceStatementPosPrint.appendTo(element[0]);
                openerp.widgetInstanceStatementPosPrint.updateId(record.id);
            }
        });
    }
})();
